﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Data.OleDb;

namespace DBAPI
{
    class clsDB
    {
            OleDbConnection Cnn = new OleDbConnection();

            public DataTable getDataTable(String queryString)
            {
                DataTable dtb = new DataTable();
                try
                {
                    if (Cnn.State != ConnectionState.Open)
                    {
                        Cnn = new OleDbConnection(clsGlobal.OleDB_ConnectionString);
                        Cnn.Open();
                        if (Cnn.State != ConnectionState.Open)
                        {
                            if (Cnn.State == ConnectionState.Connecting)
                            {
                                clsGlobal.logErr("ExecuteQuery: Cnn.State Connecting ... Wait 500 ms ", "");
                                System.Threading.Thread.Sleep(500);
                            }
                            else
                                clsGlobal.logErr("getDataTable: Cnn.State " + Cnn.State.ToString(), "");
                        }
                    }

                    OleDbDataAdapter Adapter = new OleDbDataAdapter(queryString, Cnn);
                    Adapter.Fill(dtb);
                    //Cnn.Close();
                }
                catch (Exception ex)
                {
                    clsGlobal.logErr("ERROR getDataSetBySql", ex.ToString());
                }

                return dtb;

            }


            private int ExecuteQuery(String queryString)
            {
                int numrec = -5;
                try
                {
                    //OleDbConnection Cnn = new OleDbConnection(clsGlobal.OleDB_ConnectionString);
                    if (Cnn.State != ConnectionState.Open)
                    {
                        Cnn = new OleDbConnection(clsGlobal.OleDB_ConnectionString);
                        Cnn.Open();
                        if (Cnn.State != ConnectionState.Open)
                        {
                            if (Cnn.State == ConnectionState.Connecting)
                            {
                                clsGlobal.logErr("ExecuteQuery: Cnn.State Connecting ... Wait 500 ms ", "");
                                System.Threading.Thread.Sleep(500);
                            }
                            else
                                clsGlobal.logErr("ExecuteQuery: Cnn.State " + Cnn.State.ToString(), "");
                        }

                    }

                    OleDbCommand Cmd = new OleDbCommand(queryString, Cnn);
                    numrec = Cmd.ExecuteNonQuery();
                    Cnn.Close();
                    return numrec;
                }
                catch (Exception ex)
                {
                    clsGlobal.logErr("ERROR ExecuteQuery", ex.ToString());
                    return -5;
                }
            }


            public void InsertQueueMSGAPI(string ServerName , string XML_Command, string XML_Params)
            {

                String dateSt = getDateString(DateTime.Now);

                ExecuteQuery(@"INSERT INTO [QueueMSGAPI]( [DateCreated], [ServerName], [Cmd], [Msg], [Status], [Result])" +
                     " VALUES (" + dateSt + ", '" + ServerName + "', '" + XML_Command + "', '" + XML_Params + "', 0, 0)");

            }

            public String getDateString(DateTime d)
            {
                if (clsGlobal.dbTypeID == clsGlobal.DBType.Mdb)
                {
                    return "#" + d.ToString(@"MM\/dd\/yyyy hh:mm:ss") + "#";
                }
                else //SQL
                {
                    return "'" + d.ToString(clsGlobal.SQLServerDateFormat) + "'";
                }
            }


    }
}
